SystemOrganization addCategory: #ConfigurationOfGTChatter!

Object subclass: #ConfigurationOfGTChatter
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGTChatter'!

!ConfigurationOfGTChatter class methodsFor: 'development support' stamp: 'JurajKubelka 1/12/2015 17:14'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGTChatter class methodsFor: 'private' stamp: 'JurajKubelka 1/12/2015 17:14'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGTChatter class methodsFor: 'private' stamp: 'JurajKubelka 1/12/2015 17:14'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGTChatter class methodsFor: 'private' stamp: 'JurajKubelka 1/12/2015 17:14'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGTChatter class methodsFor: 'metacello tool support' stamp: 'JurajKubelka 1/12/2015 17:14'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGTChatter class methodsFor: 'loading' stamp: 'JurajKubelka 1/12/2015 17:14'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGTChatter class methodsFor: 'loading' stamp: 'JurajKubelka 1/12/2015 17:14'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGTChatter class methodsFor: 'loading' stamp: 'JurajKubelka 1/12/2015 17:14'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGTChatter class methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 17:14'!
project

	^self new project! !

!ConfigurationOfGTChatter class methodsFor: 'development support' stamp: 'JurajKubelka 1/12/2015 17:14'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGTChatter methodsFor: 'baselines' stamp: 'JurajKubelka 1/19/2015 13:20'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/Moose/GToolkit/main'.
		spec 
			project: 'RemoteAnnouncement' with: [
				spec
					className: #ConfigurationOfRemoteAnnouncement;
					versionString: #'development';
					repository: 'http://smalltalkhub.com/mc/JurajKubelka/Configuration/main/' ];
			project: 'GlamourCore' with: [
				spec
					className: #ConfigurationOfGlamourCore;
					versionString: #'bleedingEdge';
					repository: 'http://smalltalkhub.com/mc/Moose/Glamour/main/' ].
		spec package: #'GT-Chatter' with: [
				spec requires: #('RemoteAnnouncement' 'GlamourCore' ). ]. ].
! !

!ConfigurationOfGTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 17:14'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGTChatter methodsFor: 'symbolic versions' stamp: 'JurajKubelka 1/12/2015 17:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfGTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 17:14'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
